380: (SVN1127) bugfix 18
	new: Support TLO400 adapters in adapter mode TL_Trialink2 with DMA and fast publish for act_pos, act_err and digitalInputBits
	new: TL_Axis2::digitalInputBits: Use Enum DigitalInputBits as a mask
	chg: (!) Obsolete MaximumStoppingTimeBeforeBrakeDepreciated and BrakeTimeBeforeDisableDepreciated
	chg: Default Homing-Type is DriveControlled
	chg: Remove loopback action during boot
	new: Minimum FW Release Adapter 1041 -> 1302 (because of bug in adapter FW 1301)
	chg: reduce TL_CH_AX_MAX from 32 to 16
	new: Trialink.linkErrorCounter shows sum of all drive CRC counters
	     TL_Axis2::TL_MC_AXIS_REF.linkErrorCounters.errorCountLink1/2 shows error details
	fix: publishMaster2Slave must wait for valid register from axis boot before starting
	fix: publishMaster2Slave must be disabled with last generation drives (fix 14)
	fix: Prevent calling publishSlave2Master callFast until the slow task finished (fix 14)
	fix: The actual position must be calculated with the dedicated function in the fast task (fix 14)
	chg: CNC: Sercos Interface Stub, which is required, if an axis is removed and added again (fix 14)
	chg: CNC: MAIN_FAST to GEO Task (fix 14)
	chg: CNC: Station Address starts with 10 (fix 14)
	fix: wrong data type for actual position in DMA mode for new gen drives (fix 16)
	fix: No tracking in simulation mode (fix 16)
	fix: Remove DMA for Timestamp. Leave DMA for rest (fix 17)
	fix: Gear factor was not used for actual position in DMA mode (fix 18)

375: (SVN1096)
	new: Direct feed is now also supported with stream mode (TL_DirectFeedResempling2 has to be used)
	chg: With TSD firmware >= 4.3 position latch is executed on drive for digital inputs with sampling rate of 10kHz 
	chg: Digital inputs renamed from AuxIn1..6 to DigIn1...Dig6 to be consistent with hardware manual 
	fix: Direct feed: Check is now done just for direct feed axes (bugfix1)
	fix: Position latch: version check corrected (bugfix 2)
	fix: Direct feed: df-stream does now also support simulated axes (bugfix 2)
	fix: Position latch: version check corrected (bugfix 3)
	fix: Avoid int32 over-run in timestamp wrap situations with Trialink.Config.FastBufferTicks*FAST-Cycle > 2.5 ms (bugfix 4)
	chg: Wait one tick after diagnostic stop before stop logging
	new: New axis errors up to 316 AxisCommandError
	fix: Include TL_AboSubscriberMaster5 again (bugfix 6)
	fix: Extended TL_GetCommutationPosition for register2 (bugfix 7)
	fix: TL_MC_RegisterRead type mask was not evaluated correcly (bugfix 7)
	fix: Switch off command removed as this could interrupt the enabling sequence(bugfix 8)
	fix: RL_MC_Brake and TL_BrakeConfigGet updated for TSD80(bugfix 9)
	fix: Switch off axes in case of old drives to avoid STO error - see also bugfix 8 (bugfix 10)
	fix: The check for second master in the ring should only be done once to prevent misleading error 069 (bugfix 11)
	fix: Error 317 is set in case PLC is trapped in disabling state (bugfix 12).
	new: DPRAM addresses (* 1300 *) (* 1304 *) (bugfix 12).
 	chg: Default ResetAdapterOnBoot is now FALSE, was TRUE but disabled completely in Function block (bugfix 12).
 	fix: init of MC_MoveSynchronized::Asettings was not done on restart  (bugfix 12).	
	fix: Withdraw of error 317 and return to run mode in this case. Log signals added. (bugfix 13)
        fix: If STO started in Disabled state, it sometimes showed STO-Error instead of STO-Warning due to a drive state transition issue
	fix: Add debug code to MoveAbsolute (bugfix 15)

374: (SVN1008)
    new: Broadcast globaltime every 5 seconds  (bugfix 3)
    chg: MoveSynchronized2 issues a stop if execute is set to FALSE
         This way we can stop streaming without a drive StreamLossError
    chg: Actual position is commanded position in simulation mode
    chg: use method ActualPositionFast(Trialink:=Trialink) to get interpolated positions in the fast task

373: (SVN996)
    new: Report file generation "triamec-report-2018.txt" on start of TaskExceedCompensation
    chg: default Trialink.Config.FastBufferTicks := 7
    fix: reference move caused stream loss error as data stream stoped before coupling was released (bugfix 1)	

3.7.2: (SVN982) requires FW>2083 for TSD-drives
    new: Signals.Homing.State and Distance, old Homing state Signals.General.HomingState removed
    chg: removed Config.Encoder, use drive config Parameters.PositionController.MasterPositionSource instead (FW>2082)
    chg: For TSD-drives we show the actual velocity instead of the commanded velocity in the state telegram
    chg: Changes to allow homing with option module implemented.
    new: Fast stop implemented
    fix: RDEeDRVERR_PowerLinesNotOk is interpreted as warning if RDSeDRVST_NotReadyToSwitchOn

3.7.1: (SVN913)
    new: Optimized bus access if using TL_Trialink2 and TL_Axis2
         instead of TL_Trialink, TL_AxisSlow, TL_AxisFast (FW>=5050 (TS) 2097 (TSD))
    Trialink.Config.FastFilterFrequency is the corner frequency of the commanded position filter
    new: Additional input Trialink.Diagnostics.aux allows logging external input data
	fix: replace constants enabled (bugfix 8)

3.7.0: (SVN891)
!!  breaking: This library requires FW>2087 on TSD devices due to the extended homing state feature
    new: TL_RegisterRead allows accessing 4 registers at once
	     but has no Reg12_40 and Reg4_DWORD outputs anymore
    fix: TL_PositionLatchReg2 can now latch DigInputs, but with bad timing accuracy (SLOW_TASK)
    new: TL_MC_HOME supports drive controlled homing for TSD drives (FW>2087)
    chg: The register layout was modified to account for new positionlatch features
    new: Extended state in cyclic abo used for homing state 

3.6.0: (SVN865+)
    chg: Optimization of FIFO tail access saves system load!
    new: register entries for identification, positionUnit, masterPosition, analogOut
    chg: breaking register changes:
         OptionModule.FirmwareId renamed to FirmwareRel
         TOU1[0] renamed to AnalogIn
    chg: Modifications to avoid warnings with compiler newer equal 3.1.40.20
    chg: DirectFeed: Intreface modified.
    chg: DirectFeed: Test added to check if velocity and acceleration are within the limits.
    chg: DirectFeed: Events for error publication added.
    chg: DirectFeed: Check if table position at the end of the table matches the commanded cnc position.
    fix: DirectFeed: Modulo calculation for position check fixed.

3.5.0: (SVN799+)
    new: Function blocks for direct feed re-sampling added
    chg: Modifications used for direct feed re-sampling added
	
3.4.1: (SVN782+)
    new: Reference on adjacent EncoderIndex for TSxxx drives (special application)
         use ConfigurationManager settings:
         ReferenceMethod := TL_Config.ReferenceMethod.Marker
         ReferenceFirstMask := 512; // instead of TL_Config.ReferenceFirstInput.ExtIoA
3.4.0: (SVN774)
    new: Support 24V digitalInput for homing of TSD-drives (same as for old drives)
         (latching not in drive, but in Twincat)
    chg: new entry Config.Encoder replaces TL_MC_Power.EncoderIndexForActPosition
    chg: Support for FW2077, which does no longer support old register style
    chg: BrakeTimeBeforeDisable is discarded with newer drives (TSD)
	 because brake time parameter is a config register parameter with newer drives
3.3.0: (SVN745)
    chg: remove debug signal TL_MC_AXIS::rx_test and corresponding TL_MC_Power::pub_aux
    chg: no set position zero during boot. These changes do only apply for TSD-Series drives
    chg: Register uses URI-offsets now and is not compatible for TSD80 FW < 2071
	 URI take more than 20 bits: extend internal register offset range to 22 bits
    chg: rename General.Parameters.DriveName to General.Parameters.DeviceName
    new: support for absolute endat with TSD80
	 EncoderPersistency, ReferenceDone, Digital Encoder Signals
    new: RCTtCommutationCommands2, Encoder Velocity


3.2.1: (SVN730)(TC2 SVN678)
    chg: homing is now also supported for TSD80
    chg: general enhancement of TSD80 support
    fix: if axes are coupled, homig did not work in some cases


3.2.0: (SVN713)(TC2 SVN678)
     new: support for new current controller features of FW2071 of TSD80
     chg: Changes of the drive register layout! Incompatible to earlier FW of the TSD80!

3.1.0 (SVN704, Lib310.0, TC3 only)
     new: allow receiving five (single) values per abo
     new: TSD80 support: add register layout 19 MC_AXIS.register2 and support for doubles

3.0.5: (SVN692, Lib 305.4)
     new: ReferenceType Tama, see AN108
     fix: Check for Session handler garbage collector limit, fixed
     chg: PLL correction time was 2.5*fastTaskTime, now it is constant 2.5ms. 
     chg: Diagnostic files show position error instead of actual position: Err is not interpolated, act can be seen from cmd in tracking situation (BugFix 4)
     chg: Diagnostics: adaptations for Explorer scope
     chg: reorganize error and event priorities
     chg: avoid double read of publisher abos
     fix: wrong type of PositionController.ControlOutputCurrentQ
     new: Object TL_AboSubscriberMaster5 receives 5 single float values
          Object TL_AboSubscriberMaster  receives 1 Float40 and 3 single float values (old)
     new: add missing commit option for Axis Environment
     chg: message 075 not trialink "down", but short "shutting down"
     chg: disable of moving axis first tries an emergency stop if MaximumStoppingTimeBeforeBrake<>0
     chg: pll: adjust with sample time, different windows for boot and error 179
     chg: remove obsolete events: 131, 136, 138, 139, 141, 144
     new: couple warning/error: sync 178/179 on pll sync problems
     new: task exceeds compensation 

3.0  (SVN639, Lib302.0)
     chg: Compatibility changes for TwinCat3... The following are breaking changes:
          variable "method" in homing parameter not allowed in TC3 -> ReferenceMethod
          all axis parameters are now set in TL_AxisSlow.Config
          move Trialink.FastHandler.pll.BufferTicks to Trialink.Config.FastBufferTicks
          move TL_AxisSlow.MC_axis_Home.Position to TL_AxisSlow.referencePosition
     chg: Error 069 has now a smaller priority than 070. New events 178/179
     new: Diagnostic logfile generated on axis errors
          set path in Trialink.Config.RootFolder
          an empty path or Trialink.Config.DiagnosticMode is used to disable the feature
          the number of files in this folder is limited to Trialink.Config.DiagnosticNumberOfFiles
     chg: move library_version to Diagnostics
     new: Add errors for STO firmware 1040, no parallel errors 130+260, changed event file
     new: Trialink.Config.TcEventShowReferenceInfos FALSE disables homing move information messages
     new: Trialink.Config.TcEventShowWarnings FALSE disables all warning messages
     new: 4th order interpolator for commanded positions accounts for high dynamic trajectories
     new: TL_publishSlave2Master for ts<>ts_Fast or ts/0.1ms<>n 
     new: TL_MC_MoveAbsolute can now react in MAIN_FAST, see AN108
     chg: sample codes: new TL_CNC and TL_CNC_AX with task exceed compensation capability

2.2  (SVN553, Lib226)
     new: Preparation FOR DMA with rx-iso, rx-asy, AND tx-sdram
     new: Disable axis errors if Trialink down. STO errors may be configured in Trialink.Config
     new: High resolution actual position
     new: More registers for tama and position control parameters
     chg: TL_AboSubscriberMaster flexible interpolation and modulo capability on src1
     chg: MoveAbsolute and MoveVelocity now signal 152=CommandAborted if an axis error
          stops the move before reaching the final state (standstill or ContinuousMotion)
     new: Trialink events "Booting" and "Timeout"
     chg: tiob: remove unused tRefTick, replace TL_TiobFast by TL_AboSubscriberMaster;
     chg: publish: new fifo and SingleInterpolator for TL_AboSubscriberMaster
     new: each axis has its own event source for simultaneous display
     new: Homing: add search info and show them in the event-display
      
2.1  (SVN502, Lib219)
     chg: bug fix Float40 of lib
     chg: rename FPGA localbus device DEVencoder_in_out to DEVencoder_DigIn
     chg: faster pll initialization
     new: Position-latch feature for digital IOs
     chg: recover MC_Power on communication down (*)
     chg: default direction of moveAbsolute is now shortestway (important for modulo axes)
     new: timeout error if boot not successful for 20 seconds
     chg: improve detection of two masters in the loop
     new: readyToOperate output of axis module (bridge voltage and STO detection)
     new: distinguish errors and warning for STO and bridge voltage
     fix: message events block fixed new error problem
     new: independent TwinCat errors for axis and (power/homing)
     chg: prios of errorId of TL_AxisSlow
          (1. axis error or warning 2. homing error 3. power error)
     fix: dualport ram sync problem on rx_iso fifo and sync warning
     fix: TL_publishSlave2Master bug
     chg: always set axis position to zero on ring boot
2.0 (SVN476, Lib216)
    new   : major release with changes listed in AN160 (TL_Trialink, TL_publishSlave2Slave, Homing)
    new   : Support STO
    new   : AN122 for CNC-Error 70091 in Manual und Auto Mode
    fix   : 12 hour bug
    chg   : turn off pwm if MC_Power.enable=FALSE

1.8 (SVN 393, LIB 177)
    fix   : Endat 2.1 for more than 32 bits
    change: nci-sample code with same structure as cnc

1.7 (SVN 383, LIB 176)
    fix   : moveSync does "shortest move" for proper init of Modulo axes
    fix   : Homing Setposition bug. 
    new   : SetPosition zero during communication startup
    new   : generalized register access
    change: new homing sequence statemachine
    change: rename EnableManager to AxisGroup1 and make global
    change: Triamec is now global
    change: HMI based on Visual Expres 2010
    new   : smart sync to avoid PLL not locked errors
    change: Endat 2.1: Improve error reporting and retry

1.6 (SVN279, LIB 1.6.7)
    support new AxisErrors, Endat, modulo spindle, improve interpolator
    direct sync in fasthandler, no sync task required anymore
    cleanup CNC parameters
    change: replace cnc FB "TL_AxisPath" by lib FB "TL_AxisFast" 
            but without IN/OUT components. This allows using a coordinate trafo
    change: replace cnc FB "TL_AxisModule" by lib "TL_AxisSlow"
    change: ReferenceEnable instead of ReferenceStart
            This allows controlled resetting of all axes homing flags
    note:   encoder was removed because auto-calib is default > FW1030
            to use fast encoder or Endat 2.1 see Application Notes. 

1.4 (SVN 204) changed homing behaviour: Clear Homing by Execute:=FALSE
    support stopping by an external event (e.g., endswitch-tama)
    support brake feature

1.3 Changes to the Beckhoff Sample Code of the HMI:
	simplify T-access, see HLI_DoChannelTFunction
	moved CNCSystem.T_cmd to CNCSystem.Channel[nChan].T_cmd
	moved PLC_PRG/HLI_SetAxisTrackingOperation and HLI_SetAxisFeedHold to TL_CNC_Status

	We removed the following commands in the PLC_PRG
	- HLI_SetAxisTrackingOperation in PLC_PRG
	- HLI_SetAxisFeedHold
	because these are already written in TL_CNC_FromPlc

    also be aware, that 
    - PLCAxisEnable is the global variable of the GUI for enable.




